;; Copyright (C) 2014 Ian Kelling

;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


;; do m-x benchmark-init to see some benchmark stats
;;(add-to-list 'load-path "~/.emacs.d/src/benchmark-init-el/")
;;(require 'benchmark-init-loaddefs)
;;(benchmark-init/activate)


;;; init.el --- the start of customization

;; (toggle-debug-on-error) ;uncomment to help debug

;; stop from minimizing & freezing the gui

;; Added by Package.el.  This must come before configurations of
;; installed packages.  Don't delete this line.  If you don't want it,
;; just comment it out by adding a semicolon to the start of the line.
;; You may delete these explanatory comments.
(package-initialize)

(global-unset-key (kbd "C-z"))

;; these need to be done before the hook in order to satisfy the byte compiler
;; (add-to-list 'load-path "~/.emacs.d/elpa/smartparens-20140328.809")
;; (add-to-list 'load-path "~/.emacs.d/elpa/dash-20140308.656")

;;(add-to-list 'load-path "~/.emacs.d/src/ghci-completion")
(add-to-list 'load-path "~/.emacs.d/emacs/site-lisp/org")

;; git version of gnus
;; (add-to-list 'load-path "~/.emacs.d/src/gnus/lisp")
(require 'info)
(add-to-list 'Info-default-directory-list "~/.emacs.d/src/gnus/texi")

;; needed for git version
;;(add-to-list 'load-path "~/.emacs.d/src/haskell-mode")
;;(require 'haskell-mode-autoloads)
;;(add-to-list 'Info-default-directory-list "~/.emacs.d/src/haskell-mode")

(require 'bbdb-loaddefs "~/.emacs.d/src/bbdb/lisp/bbdb-loaddefs.el")
(setq bbdb-print-tex-path "~/.emacs.d/src/bbdb/tex")

;;(add-hook 'server-visit-hook 'raise-frame)


;; load init in `after-init-hook' so all packages are loaded
;; todo, learn about the weird evaluation order of this hook that requires the quoting.
;; adapted from starter-kit
(add-hook 'after-init-hook
          `(lambda ()
             ;; todo, set this var in my-init.org and use it instead
             ;; of .emacs.d
             (setq init-dir ,(file-name-directory load-file-name))
             (unless (equal (user-uid) 0) ; don't make root owned files
               (byte-recompile-directory init-dir))
             ;; (byte-recompile-directory init-dir 0) ; with the 0,
             ;; compile .el files that have no .elc file already

             ;; this must be loaded first to avoid an error:  void-function(cl-member)
             (require 'cl)
             ;;  added org-habit, org-drill, org-mobile from the defaults
             ;; disabled because I'm not using org-drill, and I see
             ;; this error on startup of emacs server,
             ;; which might be nothing but meh,
             ;; File mode specification error: (void-function org-drill-add-cloze-fontification)

             (require 'org)
             ;; (setq org-modules (quote (org-bbdb org-bibtex org-docview org-gnus
             ;;                                    org-info org-jsinfo org-irc org-mew
             ;;                                    org-mhe org-rmail org-vm org-wl org-w3m
             ;;                                    org-habit org-drill org-mobile)))
             (org-babel-load-file (expand-file-name "my-init.org" init-dir))
             (org-babel-load-file (expand-file-name "dev.org" init-dir))))

;;init.el ends here
